library IEEE;

use IEEE.std_logic_1164.all;



entity add_4 is
  port(
    A, B : in  std_logic_vector (3 downto 0);
    Z    : out std_logic_vector (4 downto 0) );
end add_4;


architecture add_4_arc of add_4 is

component FA
	port ( A, B, carry_in : in std_logic;
	       F,   carry_out : out std_logic
	);
end component;

signal c0to1, c1to2, c2to3 : std_logic;

begin
FA_0: FA port map (A=>A(0),B=>B(0),carry_in=>'0'  ,F=>Z(0),carry_out=>c0to1);
FA_1: FA port map (A=>A(1),B=>B(1),carry_in=>c0to1,F=>Z(1),carry_out=>c1to2);
FA_2: FA port map (A=>A(2),B=>B(2),carry_in=>c1to2,F=>Z(2),carry_out=>c2to3);
FA_3: FA port map (A=>A(3),B=>B(3),carry_in=>c2to3,F=>Z(3),carry_out=>Z(4));
end add_4_arc;