library IEEE;
use IEEE.std_logic_1164.all;


entity FA is
  port (
    A, B, carry_in    : in  std_logic;
    F,    carry_out   : out std_logic );
end FA;


architecture behavioral of FA is
begin
	F <= A XOR B XOR carry_in after 30 ns;
	carry_out <= (A AND B) OR (A AND carry_in) OR (B AND carry_in) after 40 ns;
end behavioral;