library IEEE;
use IEEE.std_logic_1164.all;


entity bit_reg is
  port(
    clk   : in  std_logic;
    d_in  : in  std_logic;
    d_out : out std_logic );
end bit_reg;

architecture bit_reg_arc of bit_reg is
begin
	process (clk)
	begin
		 if (clk'event and clk='1') then
		 	d_out <= d_in after 15 ns;
		 end if;	
	end process;
end bit_reg_arc;